<template>
        <div class="row" v-if="displayBookmaker(item)" >
            <div
                class="cell"
                :class="`${type && type === 'sub' ? 'cell-bookmaker' : 'cell-logo order__logo'}`"
            >
                <a
                    target="_blank"
                    :href="refLink"
                    class="logo"
                    :style="{backgroundImage: `url('/storage/${logo || '/img/team_placeholder.svg'}')`,
                             pointerEvents : restricted ? 'none' : 'all'
                            }"
                    :title="name"
                    @click="restricted"
                >
                </a>
                <a
                    target="_blank"  class="name__book"
                    :href="refLink"
                    :style="{ pointerEvents : restricted ? 'none' : 'all' }"
                ><span>{{ name }}</span></a>

                <!--             <a href="#" class="i">i</a>-->
                <!-- <span v-if="item.b" class="b">B</span> -->
                <a
                    target="_blank"
                    :href="refLink"
                    class="link"
                    :style="{ pointerEvents : restricted ? 'none' : 'all' }"
                ></a>
            </div>
            <div class="cell cell-handicap" v-if="line !== null">
                <div class="bubble bookmaker-line">{{ line.replace(/\([^()]*\)/g, '') }}</div>
            </div>

            <div
                v-for="(coeff, coeffIdx) in item"
                :key="coeff + coeffIdx"
                class="cell cell-coeff order__coeff"
            >
                <match-table-row-bubble
                    :item="coeff"
                    @click.native="processClick(coeff,item)"
                />
            </div>

            <div class="cell cell-payout order__payout">
                <span class="percent">{{ calculatePercent(item) }}%</span>
            </div>
            <div v-if="type && type === 'sub'" class="cell cell-arr cell-empty"></div>
        </div>
</template>
<script>
    import Api from '../../../JokerApi'
    import MatchTableRowHistory from './MatchTableRowHistory'
    import MatchTableRowBubble from './MatchTableRowBubble'

    const api = new Api

    export default {
        name: 'MatchTableRow',
        components: {MatchTableRowBubble, MatchTableRowHistory},
        props: {
            eventId: {
                type: [String, Number]
            },
            marketId:{
                type: Number
            },
            item: {
                type: Object,
                required: true,
            },
            activeBetType: {
                default: '1x2',
            },
            idx: {
                required: true,
            },
            type: String,
            displayElement:{type: Boolean},
            position: Number
        },
        data() {
            return {
                betsHistory: {},
                types: {}
            }
        },
        methods: {
            processClick(coeff, item){
                if (this.$route.name ==='football.match'){
                    this.openLink(item)
                } else{
                    this.addToTracker(coeff.name);
                }
            },
            openLink(item){
                let typeName = ['1', 'X', '2'];

                if (this.marketId === 1) typeName = ['1', 'X', '2'];
                if (this.marketId === 3) typeName = ['1', '2'];
                if (this.marketId === 2) typeName = ['Over', 'Under'];
                if (this.marketId === 7) typeName = ['1X', '12', '2X'];

                if(item[typeName[0]]['bookmaker']['ref']){
                    window.open(item[typeName[0]]['bookmaker']['ref'],'_blank').focus();
                }
            },
            calculatePercent(item) {
                let itemsSum = 0
                Object.values(item).forEach(el => {
                    itemsSum += 1 / parseFloat(el.price)
                })

                return (1 / itemsSum * 100).toFixed(2)
            },
            ifSet(value) {
                if (value !== undefined && value !== false && value !== null) {
                    return value
                } else {
                    return false
                }
            },
            processTypes() {
                this.types = {}
                let types = []
                this.bets.map((bet) => {
                    Object.entries(bet.values).map(([key, value]) => {
                        types.push(key)
                    })
                });

                [...new Set(types)].map(type => {
                    this.types[type] = true
                })
            },
            addToTracker(type) {
                api.addTrackerItem(this.$cookies.get('api_remember_token'), this.eventId, this.item.market_id, type).then((res) => {
                    this.$log.debug(type, this.item.market_id, this.eventId, 'addToTracker', res)
                }).then(() => {
                    this.$root.$emit('updateTrackerItems')
                })
            },
            getType(itemTypes, choseTypes) {
                const matchedType = itemTypes.filter(element => choseTypes.includes(element))
                return matchedType[0]
            },
            displayBookmaker(item){

            let typeName = ['1', 'X', '2'];

           if (this.marketId === 1) typeName = ['1', 'X', '2'];
           if (this.marketId === 3) typeName = ['1', '2'];
           if (this.marketId === 2) typeName = ['Over', 'Under'];
           if (this.marketId === 7) typeName = ['1X', '12', '2X'];

           if(this.displayElement){
                    return  item[typeName[0]]['bookmaker']['active']
            }

            if(item[typeName[0]]['bookmaker']['selected'] && item[typeName[0]]['bookmaker']['active']){
                return 1
            } else return 0;
       }
   },
   watch: {
       item(val) {
           // this.$log.debug('item', val)
       },
   },
   created() {
       // this.$log.debug(this.item)
   },
   computed: {
       refLink() {
           return Object.values(this.item)[0].bookmaker.ref && !Object.values(this.item)[0].bookmaker.restricted ? Object.values(this.item)[0].bookmaker.ref.replace(/(^\w+:|^)/, '') : '#'
       },
       name() {
           return Object.values(this.item)[0].bookmaker.name
       },
       logo() {
           return Object.values(this.item)[0].bookmaker.logo
       },
       line() {
           return Object.values(this.item)[0].line
       },
       restricted(){
           return !!Object.values(this.item)[0].bookmaker.restricted
       }

   }
}
</script>

<style scoped>
    .logo {
        text-decoration: none;
        display: block;
        color: inherit;
    }
    .bubble.bookmaker-line {
        width: 50px;
        height: 29px;
        margin-left: 8px;
    }
</style>
